#!/usr/bin/env python3
import os
import pygame, sys
import datetime
import time
import RPi.GPIO as GPIO  # RPi.GPIO könyvtár importálása
from pygame.locals import *

pygame.init()
pygame.display.set_caption('Csengo')
windowSurfaceObj = pygame.display.set_mode((840, 480), pygame.NOFRAME, 24)
x = 200
y = 20

digit1a = pygame.image.load('/home/pi/Desktop/ora/digit/1a.png').convert()
digit2a = pygame.image.load('/home/pi/Desktop/ora/digit/2a.png').convert()
digit3a = pygame.image.load('/home/pi/Desktop/ora/digit/3a.png').convert()
digit4a = pygame.image.load('/home/pi/Desktop/ora/digit/4a.png').convert()
digit5a = pygame.image.load('/home/pi/Desktop/ora/digit/5a.png').convert()
digit6a = pygame.image.load('/home/pi/Desktop/ora/digit/6a.png').convert()
digit7a = pygame.image.load('/home/pi/Desktop/ora/digit/7a.png').convert()
digit8a = pygame.image.load('/home/pi/Desktop/ora/digit/8a.png').convert()
digit9a = pygame.image.load('/home/pi/Desktop/ora/digit/9a.png').convert()
digit0a = pygame.image.load('/home/pi/Desktop/ora/digit/0a.png').convert()
digitbl = pygame.image.load('/home/pi/Desktop/ora/digit/bl.png').convert()

data = [digit0a, digit1a, digit2a, digit3a, digit4a, digit5a, digit6a, digit7a, digit8a, digit9a]

led_color = (255, 255, 255)
button_color = (255, 0, 0)
led_rect = pygame.Rect(90, 50, 80, 80)
button_rect = pygame.Rect(50, 380, 100, 50)

led_on = False
last_toggle_time = time.time()
is_button_pressed = False

selected_file = None  # Kiválasztott fájl
file_content = []  # A fájl tartalma

alarm_times = []  # A fájlokban található időpontok tárolására

# Piros gomb állapotának kezelése
is_red_button_pressed = False

# GPIO beállítások
GPIO.setmode(GPIO.BOARD)  # A pin számok fizikai számításon alapuljanak
GPIO.setup(3, GPIO.OUT)  # A GPIO3 (BCM 2) kimenetként történő beállítása (a relé vezérléséhez)

# Beolvassa az időpontokat a kiválasztott fájl alapján
def read_alarm_times(selected_file):
    global alarm_times
    alarm_times = []  # Ürítjük az alarm_times listát
    file_path = os.path.join('/home/pi/Desktop/ora/csengetesek', selected_file)
    with open(file_path, 'r') as file:
        content = file.readlines()
        num_lines_to_read = int(content[0].strip())  # Az első sorban lévő szám
        for line in content[1:num_lines_to_read + 1]:
            alarm_time = line.strip()
            alarm_times.append(alarm_time)  # Az időpont hozzáadása a listához

def read_csengetesek_txt_files():
    directory = '/home/pi/Desktop/ora/csengetesek'
    txt_files = [f for f in os.listdir(directory) if f.endswith('.txt')]
    file_contents = []
    for file_name in txt_files:
        with open(os.path.join(directory, file_name), 'r') as file:
            content = file.readlines()
            num_lines_to_read = int(content[0].strip())  # Az első sorban lévő szám
            file_contents.append(content[1:num_lines_to_read + 1])  # A következő sorok beolvasása
    return file_contents

def read_ido_txt_files():
    directory = '/home/pi/Desktop/ora/csengetesek'
    txt_files = [f for f in os.listdir(directory) if f.endswith('.txt')]
    return txt_files

def read_file_content(file_path):
    """Beolvassa a fájlt és visszaadja a tartalmát."""
    with open(file_path, 'r') as file:
        content = file.readlines()
        num_lines_to_read = int(content[0].strip())  # Az első sorban lévő szám
        return content[1:num_lines_to_read + 1]

text_box_x = 900
text_box_y = 900
font_size = 20
font = pygame.font.Font(None, font_size)

# A fájlnevek beolvasása és a kiválasztott fájl tartalmának megjelenítése
def draw_csengetesek_file_content(file_contents):
    pygame.draw.rect(windowSurfaceObj, (255, 255, 255), Rect(text_box_x, text_box_y, 70, 376))
    if file_contents:
        y_offset = text_box_y + 10
        for content in file_contents:
            for line in content:
                text = font.render(line.strip(), True, (0, 0, 0))
                windowSurfaceObj.blit(text, (text_box_x + 10, y_offset))
                y_offset += font_size + 5  # Új sor

# Új szövegdoboz a kiválasztott fájl tartalmának kiírásához
def draw_selected_file_content(content):
    # Hozzáadunk egy új szövegdobozt, ahol a fájl tartalma jelenik meg
    content_box_x = 720
    content_box_y = 67
    pygame.draw.rect(windowSurfaceObj, (255, 255, 255), Rect(content_box_x, content_box_y, 66, 380))  # Fehér háttér
    pygame.draw.rect(windowSurfaceObj, (0, 0, 0), Rect(content_box_x, content_box_y, 200, 400), 3)  # Fekete keret

    if content:
        y_offset = content_box_y + 10
        for line in content:
            text = font.render(line.strip(), True, (0, 0, 0))
            windowSurfaceObj.blit(text, (content_box_x + 10, y_offset))
            y_offset += font_size + 5

def draw_ido_file_list(txt_files):
    pygame.draw.rect(windowSurfaceObj, (255, 255, 255), Rect(400, 237, 277, 141))
    pygame.draw.rect(windowSurfaceObj, (0, 0, 0), Rect(400, 237, 277, 141), 3)
    y_offset = 247
    for file_name in txt_files:
        # Ellenőrzés, hogy a kurzor a fájl felett van-e
        if selected_file == file_name:
            text_color = (0, 255, 0)  # Ha ki van választva, zöld
        else:
            text_color = (0, 0, 0)  # Alapértelmezett szín: fekete

        text = font.render(file_name, True, text_color)
        text_rect = text.get_rect(center=(400 + 277 // 2, y_offset + (font_size + 5) // 2))
        windowSurfaceObj.blit(text, text_rect)

        # Hover effektus: ha a kurzor a fájl neve felett van
        file_rect = pygame.Rect(400, y_offset, 277, font_size + 5)
        if file_rect.collidepoint(pygame.mouse.get_pos()):
            # Ha a kurzor fölötte van, színt változtatunk
            pygame.draw.rect(windowSurfaceObj, (200, 200, 255), file_rect, 2)  # világoskék háttér

        # Kiemelés a kiválasztott fájl számára
        if selected_file == file_name:
            pygame.draw.rect(windowSurfaceObj, (0, 255, 0), Rect(400, y_offset, 277, font_size + 5), 2)

        y_offset += font_size + 5

def draw_ok_button():
    ok_button_color = (0, 0, 255)
    ok_button_rect = pygame.Rect(400, 390, 100, 50)
    pygame.draw.rect(windowSurfaceObj, ok_button_color, ok_button_rect)
    font_rendered = font.render("Ok", True, (255, 255, 255))
    font_rect = font_rendered.get_rect(center=ok_button_rect.center)
    windowSurfaceObj.blit(font_rendered, font_rect)
    return ok_button_rect

def draw_exit_button():
    exit_button_color = (255, 0, 0)
    exit_button_rect = pygame.Rect(805, 10, 25, 30)
    pygame.draw.rect(windowSurfaceObj, exit_button_color, exit_button_rect)
    return exit_button_rect

# Piros gomb rajzolása
def draw_red_button():
    red_button_color = (255, 0, 0)
    red_button_rect = pygame.Rect(200, 380, 100, 50)  # A gomb helye és mérete
    pygame.draw.rect(windowSurfaceObj, red_button_color, red_button_rect)
    font_rendered = font.render("Hold", True, (255, 255, 255))
    font_rect = font_rendered.get_rect(center=red_button_rect.center)
    windowSurfaceObj.blit(font_rendered, font_rect)
    return red_button_rect

# LED vezérlése a piros gomb állapota alapján
def update_led_with_red_button():
    global led_color, led_on, last_toggle_time
    if is_red_button_pressed:
        led_color = (255, 0, 0)  # LED bekapcsolása, piros szín
    else:
        led_color = (255, 255, 255)  # LED kikapcsolása

# Relé vezérlés a LED állapota alapján
def control_relay():
    if led_on:  # Ha a LED világít
        GPIO.output(3, GPIO.HIGH)  # Relé bekapcsolása (5V)
    else:
        GPIO.output(3, GPIO.LOW)  # Relé kikapcsolása

# Ellenőrzi, hogy az aktuális időpont megegyezik-e a fájlban szereplő időpontokkal
def check_alarm_time(current_time):
    global led_on, last_toggle_time
    current_time_str = current_time.strftime("%H:%M:%S")  # Formázzuk az időt: "HH:MM:SS"
    if current_time_str in alarm_times:
        led_on = True
        last_toggle_time = time.time()  # LED kapcsolása

# LED vezérlése
def update_led():
    global led_color, led_on, last_toggle_time
    if led_on:
        current_time = time.time()
        if current_time - last_toggle_time <= 5:
            led_color = (0, 255, 0)  # LED bekapcsolása
        else:
            led_on = False
            led_color = (255, 255, 255)  # LED kikapcsolása

# A fájl kiválasztása és az alarm_times frissítése
def handle_file_selection(selected_file):
    read_alarm_times(selected_file)  # Frissíti az alarm_times listát
    file_path = os.path.join('/home/pi/Desktop/ora/csengetesek', selected_file)
    file_content = read_file_content(file_path)
    draw_selected_file_content(file_content)  # Kiírja a fájl tartalmát

running = True
while running:
    csengetesek_contents = read_csengetesek_txt_files()
    ido_files = read_ido_txt_files()

    now = datetime.datetime.now()
    check_alarm_time(now)  # Az aktuális idő ellenőrzése a beolvasott időpontokkal

    # A LED vezérlése
    update_led_with_red_button()  # LED vezérlése a piros gomb állapota alapján
    control_relay()  # A relé vezérlése a LED állapotától függően

    hournow = str(now.hour).zfill(2)
    minsnow = str(now.minute).zfill(2)
    secsnow = str(now.second).zfill(2)
    digit1 = data[int(str(hournow)[0:1])]
    digit2 = data[int(str(hournow)[1:2])]
    digit3 = data[int(str(minsnow)[0:1])]
    digit4 = data[int(str(minsnow)[1:2])]
    digit5 = data[int(str(secsnow)[0:1])]
    digit6 = data[int(str(secsnow)[1:2])]

    windowSurfaceObj.blit(digitbl, (x + 0, y + 0))
    digit1.set_colorkey(0, pygame.RLEACCEL)
    windowSurfaceObj.blit(digit1, (x + 0, y + 0))
    windowSurfaceObj.blit(digitbl, (x + 72, y + 0))
    digit2.set_colorkey(0, pygame.RLEACCEL)
    windowSurfaceObj.blit(digit2, (x + 72, y + 0))
    windowSurfaceObj.blit(digitbl, (x + 150, y + 0))
    digit3.set_colorkey(0, pygame.RLEACCEL)
    windowSurfaceObj.blit(digit3, (x + 150, y + 0))
    windowSurfaceObj.blit(digitbl, (x + 222, y + 0))
    digit4.set_colorkey(0, pygame.RLEACCEL)
    windowSurfaceObj.blit(digit4, (x + 222, y + 0))
    windowSurfaceObj.blit(digitbl, (x + 300, y + 0))
    digit5.set_colorkey(0, pygame.RLEACCEL)
    windowSurfaceObj.blit(digit5, (x + 300, y + 0))
    windowSurfaceObj.blit(digitbl, (x + 372, y + 0))
    digit6.set_colorkey(0, pygame.RLEACCEL)
    windowSurfaceObj.blit(digit6, (x + 372, y + 0))

    pygame.draw.rect(windowSurfaceObj, (0, 0, 0), Rect(x, y - 107, 450, 107))
    pygame.draw.rect(windowSurfaceObj, (0, 0, 0), Rect(x, y + 107, 450, 107))
    pygame.draw.rect(windowSurfaceObj, (0, 100, 0), Rect(x - 5, y - 5, 452, 117), 2)

    pygame.draw.rect(windowSurfaceObj, led_color, led_rect)  # LED
    pygame.draw.rect(windowSurfaceObj, button_color, button_rect)  # Piros gomb

    font_rendered = font.render("Fire", True, (255, 255, 255))
    font_rect = font_rendered.get_rect(center=button_rect.center)
    windowSurfaceObj.blit(font_rendered, font_rect)

    led_text = font.render("Led", True, (255, 255, 255))
    led_text_rect = led_text.get_rect(center=led_rect.center)
    windowSurfaceObj.blit(led_text, led_text_rect)

    draw_csengetesek_file_content(csengetesek_contents)
    draw_ido_file_list(ido_files)

    # Piros gomb rajzolása
    red_button_rect = draw_red_button()

    ok_button_rect = draw_ok_button()
    exit_button_rect = draw_exit_button()

    pygame.display.update()

    for event in pygame.event.get():
        if event.type == MOUSEBUTTONDOWN:
            if exit_button_rect.collidepoint(event.pos):
                pygame.quit()
                running = False
                break

            if button_rect.collidepoint(event.pos):
                if not is_button_pressed:
                    is_button_pressed = True
                    led_on = not led_on

            # Kattintás a piros gombra
            if red_button_rect.collidepoint(event.pos):
                is_red_button_pressed = True

            # Kattintás a fájlnevekre
            for i, file_name in enumerate(ido_files):
                file_rect = pygame.Rect(400, 247 + (font_size + 5) * i, 277, font_size + 5)
                if file_rect.collidepoint(event.pos):
                    selected_file = file_name
                    file_content = []  # Üresítjük ki a fájl tartalmát, ha új fájlt választanak

            if ok_button_rect.collidepoint(event.pos) and selected_file:
                file_path = os.path.join('/home/pi/Desktop/ora/csengetesek', selected_file)
                file_content = read_file_content(file_path)
                handle_file_selection(selected_file)  # A fájl kiválasztása és annak tartalmának megjelenítése

        if event.type == MOUSEBUTTONUP:
            if button_rect.collidepoint(event.pos):
                is_button_pressed = False

            # Felengedés a piros gombnál
            if red_button_rect.collidepoint(event.pos):
                is_red_button_pressed = False

    update_led_with_red_button()  # LED vezérlése a piros gomb állapota alapján
    update_led()  # LED frissítése a megfelelő időzítéssel

    time.sleep(0.1)